"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ruleName = void 0;
const stylelint_1 = __importDefault(require("stylelint"));
const properties_order_1 = __importDefault(require("stylelint-order/rules/properties-order"));
const config_creator_1 = __importDefault(require("../config/config-creator"));
const ruleName = "plugin/chrome-devtools-order";
exports.ruleName = ruleName;
const plugin = ((enabled, options, context) => (root, result) => {
    if (!enabled) {
        return;
    }
    const validOptions = stylelint_1.default.utils.validateOptions(result, ruleName, {
        actual: enabled,
        possible: [true, false],
    }, {
        actual: options,
        optional: true,
        possible: {
            "empty-line-between-categories": [true, false],
        },
    });
    if (!validOptions) {
        throw TypeError(`The options received for ${ruleName} are invalid: ${JSON.stringify(options)}`);
    }
    const expectation = config_creator_1.default(options);
    properties_order_1.default(expectation, undefined, context)(root, result);
});
exports.default = stylelint_1.default.createPlugin(ruleName, plugin);
